#include <unistd.h>
#include <sys/dos.h>
#include <sys/iocs.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>

int select(width, rout, wout, eout, timeout)
int width;
fd_set *rout, *wout, *eout;
struct timeval *timeout;
{
	fd_set rorig,worig,eorig;
	int nfound = 0;
	long lim;
	int select_intr_flg;

	if( timeout ){
		lim = _dos_time_pr() + timeout->tv_sec * 1000 + timeout->tv_usec / 1000;
	}

	if( rout ){
		rorig = *rout;
		FD_ZERO(rout);
	}

	if( wout ){
		worig = *wout;
		FD_ZERO(wout);
	}

	if( eout ){
		eorig = *eout;
		FD_ZERO(eout);
	}

	select_intr_flg = 0;

	do {
		int i;
		int nflag = 0;

		for(i=0;i<width && !select_intr_flg;i++){
			if( rout && FD_ISSET(i,&rorig) ){
				if (i >= 128) {
				/* socketȂ socklen g */
					if (socklen(i, 0)) {
						FD_SET(i, rout);
						nflag = 1;
					}
				} else if( isatty(i) ){
				/* consoleȂdosR[Œׂ */
					if( _dos_k_keysns() ){
						FD_SET(i,rout);
						nflag = 1;
					}
				}else{
				/* consolełȂ΁Aɓǂݍ߂邱Ƃɂ */
					FD_SET(i,rout);
					nflag = 1;
				}
			}

			if( wout && FD_ISSET(i,&worig) ){
				/* ǂȃfoCXłɏo邱Ƃɂ */
				FD_SET(i,wout);
				nflag = 1;
			}

#if 0
			/* O͋N蓾ȂƂɂ */
			if( eout && FD_ISSET(i,&eorig) ){
				/* ........ */
			}
#endif

			if( nflag ){
				nfound++;
				nflag = 0;
			}
		}
		if( nfound )
			break;

		select_intr_flg = _iocs_bitsns(0x0a) & 0x10;
		_dos_change_pr();

	}while((!timeout || ((lim-_dos_time_pr())>0)) && !select_intr_flg);

	if (select_intr_flg)
	{
		errno = EINTR;
		return -1;
	}
	return nfound;
}
